//
//  WeissmanBeckCalculator.swift
//  psychology_ios_native
//
//  Created by Eldar Goloviznin on 15/10/2019.
//  Copyright © 2019 Psychology. All rights reserved.
//

import Foundation

struct Pair {
    let key: String
    let value: Int
}

struct WeissmanBeckCalculator: TestCalculator {
    
    let test: Test
    
    private static let summirizedIndexies: Set<Int> = [
        2, 6, 12, 17, 18, 23, 24, 29, 30, 35, 37, 40
    ]
    
    /**
     Input:
     Часть пунктов, согласно ключу, имеет прямую оценку, соответствующую баллу выбора, а часть – обратную, соответственно:
     Выбор испытуемого:      1 2 3 4 5 6 7
     Оценочный балл:            7 6 5 4 3 2 1

     Баллы пунктов 2,  6,  12,  17,  18,  23,  24,  29,  30,  35,  37,  40 суммируем
     Баллы пунктов 1,  3,  4,  5,  7,  8,  9,  10,  11,  13,  14,  15,  16,  19,  20,  21,  22,  25,  26,  27,  28,  31,  32,  33,  34,  36,  38,  39) имеют обратную оценку. Переворачиваем и суммируем.
     
     Output: Выводим общую сумму по всем вопросам.
     Варианты ответа:
     Если от 103 -  до  138  баллов, то ответ:
     У вас встречаются ошибки мышления, но их количество не превышает уровень нормы.
     Если количество  баллов  102  и  менее, то ответ
     Поздравляем, у вас очень мало ошибок мышления.
     Если количество  баллов  от  139  и  более, то ответ:
     К сожалению, вы допускаете много ошибок мышления, часто даете неадекватную оценку ситуациям. Обычно это приводит к длительным негативным эмоциям или даже телесным симптомам. Рекомендуем поработать над своими мыслями.
     Комментарии:
     В этом тесте важно еще и сохранить и все ответы на вопросы, а не только общий балл.
     Степень выраженности дисфункциональных отношений определяется через общий суммарный балл по опроснику. Анализ выбора ответа по каждому отдельному утверждению позволяет выявить выраженность отдельных дисфункциональных отношений. Чем выше соответствующая оценка отдельного пункта опросника и, таким образом, суммарная оценка теста, тем более искаженным диагностируются когнитивные характеристики.
     Какой ответ следует рассматривать как функциональный и приемлемый, т.е. реалистический, а какой – как дисфункционалный и неприемлемый (неадекватный), было установлено авторами при помощи оценочного кода на основе предварительных исследований.
     Ряд утверждений опросника имеют характер дисфункциональных отношений катастрофичности (пункты №№ 3, 5, 12, 14, 27, 28, 32, 39 и др.), другие относятся к дисфункциональным отношениям сверхгенерализации (пункты №№ 29, 31 и др.), перфекционизма (пункты 4, 20, 21, 25 и др.), эскапизма (п.36), оценочным отношениям (пп. 9 и др.)

     */

    func calculate(summary: TestAnswerSummary) -> TestResult {
        let answers = summary.answers
        
        var sum = 0
        
        var pairs: [Pair] = []
        
        for (index, answer) in answers.enumerated() {
            var weight = answer.weight
            if !WeissmanBeckCalculator.summirizedIndexies.contains(index + 1) {
                weight = 8 - weight
            }
            pairs.append(Pair(key: "_\(index)", value: weight))
            sum += weight
        }
        
        pairs.append(Pair(key: "_41", value: sum))
        
        let advice: String
        
        switch sum {
        case ..<103: advice = "Поздравляем, у вас очень мало ошибок мышления."
        case 103 ... 138: advice = "У вас встречаются ошибки мышления, но их количество не превышает уровень нормы."
        case 139...: advice = "К сожалению, вы допускаете много ошибок мышления, часто даете неадекватную оценку ситуациям. Обычно это приводит к длительным негативным эмоциям или даже телесным симптомам. Рекомендуем поработать над своими мыслями."
        default: fatalError()
        }
        
        let title = "Вы набрали \(sum.markFormatted)"
        
        return TestResult(test: test, results: [ResultDescription(title: title, advice: advice)], res: Res(title: "ШДО", pairs: pairs))
    }
    
}
